# Rack Dispatcher
require 'rubygems'
require 'rack'
require 'live_management'
require 'logger'

require "#{File.dirname(__FILE__)}/../console-auth/lib/console_auth"

if ::ConsoleAuth.active?
  Gem.use_paths nil, ["#{File.dirname(__FILE__)}/../console-auth/vendor/rubygems"]

  require "#{File.dirname(__FILE__)}/../console-auth/lib/cas_client"
  require "#{File.dirname(__FILE__)}/../console-auth/lib/rack_authorization"

  ::ConsoleAuth.init

  use Rack::Session::Cookie,
    :key => ::ConsoleAuth.get_config['authentication']['session_key'],
    :secret => ::ConsoleAuth.get_config['authentication']['session_secret']

  use Rack::Cas::Client,
    :cas_base_url => ::ConsoleAuth.cas_base_url,
    :session_dir => './tmp/sessions',
    :logger => Logger.new('/var/log/pe-console-auth/cas_client.log'),
    :cas_port => ::ConsoleAuth.get_config['authentication']['cas_port'],
    :allow_unauthenticated_urls => ::ConsoleAuth.unauthenticated_restrictions

  use Rack::ConsoleAuth::Authorization
end

use Rack::Static, :urls => ["/images", "/javascript", "/stylesheets"], :root => "public"

run LiveManagement
